Bug 59848 - [ChromiumWin] Font::drawComplexText calls EndPlatformPaint without calling BeginPlatformPaint
Summary: [ChromiumWin] Font::drawComplexText calls EndPlatformPaint without calling Be...
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Platform (show other bugs)
Version: 528+ (Nightly build)
Hardware: PC All
: P2 Normal
Assignee: Nobody
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2011-04-29 17:23 PDT by Chris Guillory
Modified: 2011-05-10 17:34 PDT (History)
4 users (show)

See Also:


Attachments
Patch (1.48 KB, patch)
2011-04-29 17:26 PDT, Chris Guillory
no flags Details | Formatted Diff | Diff
Proposed Patch (1.68 KB, patch)
2011-05-06 18:45 PDT, Chris Guillory
no flags Details | Formatted Diff | Diff
Address issue uncovered by proposed Chromium test patch. (2.11 KB, patch)
2011-05-10 15:34 PDT, Chris Guillory
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Chris Guillory 2011-04-29 17:23:52 PDT
This issue was discovered while investigating http://crbug.com/80616.

Looks like the call to endPlatformPaint should have been removed in this changeset 41978.
http://trac.webkit.org/changeset/41978/trunk/WebCore/platform/graphics/chromium/FontChromiumWin.cpp.
Comment 1 Chris Guillory 2011-04-29 17:26:18 PDT
Created attachment 91771 [details]
Patch
Comment 2 Eric Seidel (no email) 2011-05-01 09:52:04 PDT
Comment on attachment 91771 [details]
Patch

You might try webkit-patch upload for your next patch.  It will automatically check the patch checkbox, etc. when uploading.
Comment 3 Eric Seidel (no email) 2011-05-01 09:52:57 PDT
Comment on attachment 91771 [details]
Patch

OK.  How do we test this?  Recently there was a RIAA added for GraphicsContext::save/restore which helped get rid of a bunch of bugs like this in the cross-platofrm code.
Comment 4 Eric Seidel (no email) 2011-05-01 09:54:37 PDT
Comment on attachment 91771 [details]
Patch

Seems we either need a test or an explanation of why testing is impossible in your ChangeLog. I don't think we can test printing with DumpRenderTree.  So if printing is required to test this, automated testing may be impossible.
Comment 5 Chris Guillory 2011-05-06 18:31:10 PDT
One way to "test" would be to have the non-printing case fail (in debug mode) when this bug occurs. I have a Chromium change out for review for that.
http://codereview.chromium.org/6949012/
Comment 6 Chris Guillory 2011-05-06 18:45:54 PDT
Created attachment 92675 [details]
Proposed Patch

Adding testing information.
Comment 7 Chris Guillory 2011-05-10 14:57:48 PDT
Comment on attachment 92675 [details]
Proposed Patch

Patch needs to be updated to address errors uncovered by chromium change.
Comment 8 Chris Guillory 2011-05-10 15:34:23 PDT
Created attachment 93030 [details]
Address issue uncovered by proposed Chromium test patch.

Adding testing information.
Comment 9 James Robinson 2011-05-10 15:41:54 PDT
Comment on attachment 93030 [details]
Address issue uncovered by proposed Chromium test patch.

Hurray for testing!
Comment 10 WebKit Commit Bot 2011-05-10 17:33:57 PDT
Comment on attachment 93030 [details]
Address issue uncovered by proposed Chromium test patch.

Clearing flags on attachment: 93030

Committed r86199: <http://trac.webkit.org/changeset/86199>
Comment 11 WebKit Commit Bot 2011-05-10 17:34:02 PDT
All reviewed patches have been landed.  Closing bug.